# exercise 5.2.4
import sklearn.linear_model as lm

# requires wine data from exercise 5.1.5
from ex5_1_5 import *
from matplotlib.pylab import figure, hist, plot, show, subplot, xlabel, ylabel

# Split dataset into features and target vector
alcohol_idx = attributeNames.index("Alcohol")
y = X[:, alcohol_idx]

X_cols = list(range(0, alcohol_idx)) + list(range(alcohol_idx + 1, len(attributeNames)))
X = X[:, X_cols]

# Fit ordinary least squares regression model
model = lm.LinearRegression()
model.fit(X, y)

# Predict alcohol content
y_est = model.predict(X)
residual = y_est - y

# Display scatter plot
figure()
subplot(2, 1, 1)
plot(y, y_est, ".")
xlabel("Alcohol content (true)")
ylabel("Alcohol content (estimated)")
subplot(2, 1, 2)
hist(residual, 40)

show()

print("Ran Exercise 5.2.4")
